CAD开发者社区

 找回密码
 立即注册

QQ登录

只需一步,快速开始

ActiveX 开发指南

相关分类

质心属性 (ActiveX)

2023-1-3 20:47| 发布者: admin| 查看: 420| 评论: 0|来自: AutoCAD

摘要: 获取区域或实体的面积或质量中心。

获取区域或实体的面积或质量中心。

支持的平台:仅窗口

签名

工 务 局:

object.Centroid
对象

类型:3DSolid地区

此属性适用的对象。

属性值

只读:是的

类型:变体(双精度的双元素数组)

表示质心的 2D 坐标。

言论

质心返回为定义为变体的XY坐标。

例子

工 务 局:

Sub Example_Centroid()
    ' This example creates a box in model space.
    ' It then returns the Centroid for that box.
    
    Dim boxObj As Acad3DSolid
    Dim length As Double, width As Double, height As Double
    Dim center(0 To 2) As Double
    
    ' Define the box
    center(0) = 5#: center(1) = 5#: center(2) = 0
    length = 5#: width = 7: height = 10#
    
    ' Create the box (3DSolid) object in model space
    Set boxObj = ThisDrawing.ModelSpace.AddBox(center, length, width, height)
    
    ' Change the viewing direction of the viewport to better see the box
    Dim NewDirection(0 To 2) As Double
    NewDirection(0) = -1: NewDirection(1) = -1: NewDirection(2) = 1
    ThisDrawing.ActiveViewport.direction = NewDirection
    ThisDrawing.ActiveViewport = ThisDrawing.ActiveViewport
    ZoomAll
    
    ' Return the Centroid for the box
    Dim Centroid As Variant
    Centroid = boxObj.Centroid
    MsgBox "The Centroid for the box is " & Centroid(0) & ", " & Centroid(1), , "Centroid Example"
        
End Sub

Visual LISP:

(vl-load-com)
(defun c:Example_Centroid()
    ;; This example creates a box in model space.
    ;; It then returns the Centroid for that box.
    (setq acadObj (vlax-get-acad-object))
    (setq doc (vla-get-ActiveDocument acadObj))
  
    ;; Define the box
    (setq center (vlax-3d-point 5 5 0)
          boxLength 5
	         boxWidth 7
	         boxHeight 10)
    
    ;; Create the box (3DSolid) object in model space
    (setq modelSpace (vla-get-ModelSpace doc))
    (setq boxObj (vla-AddBox modelSpace center boxLength boxWidth boxHeight))
    
    ;; Change the viewing direction of the viewport to better see the box
    (setq NewDirection (vlax-3d-point -1 -1 1))
    (setq activeViewport (vla-get-ActiveViewport doc))
    (vla-put-Direction activeViewport NewDirection)
    (vla-put-ActiveViewport doc activeViewport)
    (vla-ZoomAll acadObj)
    
    ;; Return the Centroid for the box
    (setq Centroid (vlax-safearray->list (vlax-variant-value (vla-get-Centroid boxObj))))
    (alert (strcat "The Centroid for the box is " (rtos (nth 0 Centroid) 2) ", " (rtos (nth 1 Centroid) 2)))
)

路过

雷人

握手

鲜花

鸡蛋

最新评论

QQ|Archiver|CAD开发者社区 ( 苏ICP备2022047690号-1 )

GMT+8, 2024-5-12 07:43

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

返回顶部